## Zope PostgreSQL DataBase Adapter based on PoPy Python Postgres Driver 
## --------------------------------------------------------------------- 

## Copyright (c) 2000 - Thierry MICHEL 
## Copyright (c) 2000 - MixadLive srl Torino, Italy 
## http://www.mixadlive.com 

## This library is free software, you can redistribute it and/or 
## modify it under the terms of the GNU General Public Licence as  
## published by the Free Software Foundation. 

## This program is distributed in the hope that it will be useful, 
## but WITHOUT ANY WARRANTY; without even the implied warranty of 
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
## GNU General Public License for more details 

## You should have received a copy of the GNU General Public License 
## along with this program; if not, write to the Free Software 
## Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. 

## MixadLive, Srl., hereby disclaims all copyright 
## interest in the Zope Database Adapter `ZPoPyDA' written  
## by Thierry MICHEL 

## -- Thierry - Developer 
## For bugs & comments: thierry@developers.mixadlive.com 


database_type='PoPy'

"""%s Database Connection""" % database_type
__version__='$Revision: 1.11 $'[11:-2]


from PoPy_db import DB
import Shared.DC.ZRDB.Connection
from App.Dialogs import MessageDialog
from Globals import HTMLFile
import Globals
import string

addConnectionForm=HTMLFile(
    'Products/ZPoPyDA/PoPyconnectionAdd',
    default_id='%s_database_connection' % database_type,
    default_title='Z %s Database Connection' % database_type,
    database_type=database_type,
    )

def addConnection(self, id, title, connection_string, connected=None,boolStyle=None,autocommit=None,attempts=10,seconds=5,REQUEST=None):
    """Add a Z PoPy DB connection to a folder"""
    if autocommit is None:
        autocommit = 'OFF'
    else:
        autocommit = 'ON'
        
    if not connected is None:
        connected = 1
    if boolStyle is None:
        boolStyle = 'NEW'
    else: boolStyle = 'OLD'
    
    self._setObject(id, Connection(id, title,connection_string,connected,boolStyle,autocommit,attempts,seconds))
    if REQUEST is not None: return self.manage_main(self,REQUEST)

class Connection(Shared.DC.ZRDB.Connection.Connection):
    """A database connection object"""
    database_type=database_type
    id='%s_database_connection' % database_type
    meta_type=title='Z %s Database Connection' % database_type
    icon='misc_/Z%sDA/conn' % database_type
    _isAnSQLConnection=1

    
    def __init__(self, id, title, connection_string, connected=None,boolStyle='OLD',autocommit='ON',attempts=10,seconds=5):
##        f = open("/tmp/zope.debug","a")
##        f.write("Connection __init__ call\n")
##        f.close()
        self.id=id
        self.autocommit = autocommit
        self.edit(title, connection_string, connected)
        self.attempts = attempts
        self.seconds = seconds
        self.boolStyle = boolStyle
        
        if self._v_connected:
            self._v_database_connection.setAttempts(attempts,seconds)

        if self._v_connected and boolStyle == 'OLD':
            self._v_database_connection.boolOldStyle(1)
        elif self._v_connected:
            self._v_database_connection.boolOldStyle(0)

        if self._v_connected and autocommit == 'ON':
            self._v_database_connection.autoCommit(1)
        elif self._v_connected:
            self._v_database_connection.autoCommit(0)


    def manage_open_connection2(self, REQUEST=None):
        " "
        self.connect(self.connection_string)
##        f = open("/tmp/zope.debug","a")
##        f.write("Connection open_connection call\n")
##        f.write("AUTOCOMMIT MODE %s\n" % self.autocommit)
##        f.close()

        if self._v_connected and self.boolStyle == 'OLD':
            self._v_database_connection.boolOldStyle(1)
        elif self._v_connected:
            self._v_database_connection.boolOldStyle(0)
            
        if self._v_connected and self.autocommit == 'ON':
            self._v_database_connection.autoCommit(1)
        elif self._v_connected:
            self._v_database_connection.autoCommit(0)
        else:
            self.autocommit = 'OFF'
            
        return self.manage_main(self, REQUEST)

    def manage_attempts (self, attempts,seconds,REQUEST):
        " "
        self.attempts = attempts
        self.seconds = seconds
        self._v_database_connection.setAttempts(attempts,seconds)
        return self.manage_main(self,REQUEST)

    def manage_boolStyle (self, boolStyle,REQUEST):
        " "
        self.boolStyle = boolStyle
        if boolStyle == 'OLD':
            self._v_database_connection.boolOldStyle(1)
        else:
            self._v_database_connection.boolOldStyle(0)
            
        return self.manage_main(self,REQUEST)
    
    def manage_autocommit (self, autocommit,REQUEST):
        " "
        
        self.autocommit = autocommit

        if self._v_connected and autocommit == 'ON':
            self._v_database_connection.autoCommit(1)
        elif self._v_connected:
            self._v_database_connection.autoCommit(0)
        return self.manage_main(self,REQUEST)

    manage_main=HTMLFile('PoPyconnectionStatus', globals())

    def oldStyled (self):
        if self.boolStyle == 'OLD':
            return self.boolStyle
        return None
    
    def autocommitted (self):
        "Testing the auto commit mode "
        if self.autocommit == 'OFF':
            return None
        return self.autocommit

    manage_properties=HTMLFile('PoPyconnectionEdit', globals())

    def manage_edit(self, title, connection_string, connected=None, boolStyle=None,autocommit=None,attempts=10,seconds=5,REQUEST=None):
        """Change connection"""
        if autocommit is None:
            autocommit = 'OFF'
        else:
            autocommit = 'ON'
            
        self.autocommit = autocommit
        if boolStyle is None:
            self.boolStyle = 'NEW'
        else : self.boolStyle = 'OLD'

        if self._v_connected and self.boolStyle == 'OLD':
            self._v_database_connection.boolOldStyle(1)
        elif self._v_connected:
            self._v_database_connection.boolOldStyle(0)

        if self._v_connected and autocommit == 'ON':
            self._v_database_connection.autoCommit(1)
        elif self._v_connected:
            self._v_database_connection.autoCommit(0)
        
        self.edit(title, connection_string, connected)

        self.attempts = attempts
        self.seconds = seconds
        self._v_database_connection.setAttempts(attempts,seconds)


        if REQUEST is not None:
            return MessageDialog(title='Edited',
                                 message='<strong>%s</strong> has been edited.' % self.id,
                                 action ='./manage_main',
                                 )

    def __setstate__(self, state):
        Globals.Persistent.__setstate__(self, state)
##        f = open("/tmp/zope.debug","a")
##        f.write("Connection __set_state call\n")
##        f.close()

        if self.connection_string:
            try:
                self.connect(self.connection_string)
                if self._v_connected and self.autocommit == 'ON':
                    self._v_database_connection.autoCommit(1)
                elif self._v_connected:
                    self._v_database_connection.autoCommit(0)
                else:
                    self.autocommit = 'OFF'
            except: pass
##        f = open("/tmp/zope.debug","a")
##        f.write("Connection set_state end\n")
##        f.close()
        

    def edit(self, title, connection_string, check=1):
##        f = open("/tmp/zope.debug","a")
##        f.write("Connection edit call\n")
##        f.close()
        self.title=title
        self.connection_string=connection_string
        if check == 1:
            self.connect(connection_string)
            if self._v_connected and self.autocommit == 'ON':
                self._v_database_connection.autoCommit(1)
                 
    manage_testForm = HTMLFile('PoPyconnectionTestForm', globals())
    
    def factory(self): return DB

    def sql_quote__(self, v, escapes={
        '\\': '\\\\',
        '\"': '\\\"',
        '\'': '\\\'',
        '\0': '\\0',
        '\n': '\\n',
        '\t': '\\t', 
        '\r': '\\r',
        '\b': '\\n',
        }):
        find=string.find
        for c in "\\\"\'\0\n\t\r\b":
            if find(v,c) > -1:
                v=string.join(string.split(v,c),escapes[c])
        return "'%s'" % v
